"use strict";
var __createBinding = (this && this.__createBinding) || (Object.create ? (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    var desc = Object.getOwnPropertyDescriptor(m, k);
    if (!desc || ("get" in desc ? !m.__esModule : desc.writable || desc.configurable)) {
      desc = { enumerable: true, get: function() { return m[k]; } };
    }
    Object.defineProperty(o, k2, desc);
}) : (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    o[k2] = m[k];
}));
var __setModuleDefault = (this && this.__setModuleDefault) || (Object.create ? (function(o, v) {
    Object.defineProperty(o, "default", { enumerable: true, value: v });
}) : function(o, v) {
    o["default"] = v;
});
var __importStar = (this && this.__importStar) || function (mod) {
    if (mod && mod.__esModule) return mod;
    var result = {};
    if (mod != null) for (var k in mod) if (k !== "default" && Object.prototype.hasOwnProperty.call(mod, k)) __createBinding(result, mod, k);
    __setModuleDefault(result, mod);
    return result;
};
var __exportStar = (this && this.__exportStar) || function(m, exports) {
    for (var p in m) if (p !== "default" && !Object.prototype.hasOwnProperty.call(exports, p)) __createBinding(exports, m, p);
};
var __awaiter = (this && this.__awaiter) || function (thisArg, _arguments, P, generator) {
    function adopt(value) { return value instanceof P ? value : new P(function (resolve) { resolve(value); }); }
    return new (P || (P = Promise))(function (resolve, reject) {
        function fulfilled(value) { try { step(generator.next(value)); } catch (e) { reject(e); } }
        function rejected(value) { try { step(generator["throw"](value)); } catch (e) { reject(e); } }
        function step(result) { result.done ? resolve(result.value) : adopt(result.value).then(fulfilled, rejected); }
        step((generator = generator.apply(thisArg, _arguments || [])).next());
    });
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.parseDocs = void 0;
const fs = __importStar(require("fs-extra"));
const path = __importStar(require("path"));
const DocsParser_1 = require("./DocsParser");
function parseDocs(options) {
    return __awaiter(this, void 0, void 0, function* () {
        const packageMode = options.packageMode || 'single';
        const apiDocsPath = path.resolve(options.baseDirectory, 'docs', 'api');
        const structuresPath = path.resolve(apiDocsPath, 'structures');
        let structures = [];
        let apis = [];
        if (options.useReadme) {
            const readmePath = path.resolve(options.baseDirectory, 'README.md');
            if (!fs.existsSync(readmePath)) {
                throw new Error('README.md file not found');
            }
            apis = [readmePath];
        }
        else {
            structures = yield getAllMarkdownFiles(structuresPath);
            apis = yield getAllMarkdownFiles(apiDocsPath);
        }
        const parser = new DocsParser_1.DocsParser(options.baseDirectory, options.moduleVersion, apis, structures, packageMode);
        return yield parser.parse();
    });
}
exports.parseDocs = parseDocs;
function getAllMarkdownFiles(inDir) {
    return __awaiter(this, void 0, void 0, function* () {
        const allMarkdownFiles = [];
        const children = yield fs.readdir(inDir);
        for (const child of children) {
            const childPath = path.resolve(inDir, child);
            const stats = yield fs.stat(childPath);
            if (path.extname(childPath) === '.md' && stats.isFile()) {
                allMarkdownFiles.push(childPath);
            }
        }
        return allMarkdownFiles;
    });
}
__exportStar(require("./ParsedDocumentation"), exports);
//# sourceMappingURL=index.js.map